#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivExchange.h"
std::auto_ptr<M_ActivExchange> M_ActivExchange::msSingleton(nullptr);

int M_ActivExchange::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivExchangeData* M_ActivExchange::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivExchangeData>& M_ActivExchange::GetMapData()
{
	return mMapData;
}

void M_ActivExchange::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivExchange.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivExchangeData data;
		data.mID = element->IntAttribute("ID");
		{
			const char* ExchangeItems = element->Attribute("ExchangeItems");
			std::vector<std::string> vecExchangeItems;
			boost::split(vecExchangeItems, ExchangeItems, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecExchangeItems.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecExchangeItems[i].c_str(), &temp))
				{
					data.mExchangeItems.push_back(temp);
				}
			}
		}
		{
			const char* QuantityRequired = element->Attribute("QuantityRequired");
			std::vector<std::string> vecQuantityRequired;
			boost::split(vecQuantityRequired, QuantityRequired, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecQuantityRequired.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecQuantityRequired[i].c_str(), &temp))
				{
					data.mQuantityRequired.push_back(temp);
				}
			}
		}
		data.mGetItems = element->IntAttribute("GetItems");
		data.mGetQuantity = element->IntAttribute("GetQuantity");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivExchange Loaded. Load Data:%u", mMapData.size());
}

void M_ActivExchange::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivExchange");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivExchange");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivExchangeData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readVectorInt(L, "ExchangeItems", data.mExchangeItems);
		LuaCfgHelper::readVectorInt(L, "QuantityRequired", data.mQuantityRequired);
		LuaCfgHelper::readInt(L, "GetItems", data.mGetItems);
		LuaCfgHelper::readInt(L, "GetQuantity", data.mGetQuantity);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivExchange Loaded. Load Data:%u", mMapData.size());
}

void M_ActivExchange::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivExchange* M_ActivExchange::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivExchange());
	}
	return msSingleton.get();
}

void M_ActivExchange::Release()
{
	msSingleton.reset(nullptr);
}
